//-----------------------------------------------------------------------------
//  TimpyH_MSD_Sect_Serv.h
//-----------------------------------------------------------------------------
//
//  Copyright 2006, 2007 Chiaki Nakajima
//  Original copyright 2006 Silicon Laboratories, Inc.
//
//  Release 1.1
//      E\[X̐
//      EgpvZbTF340ɌC"__F340_VER__"`QƂ폜
//      Et@C"F34x_""TimpyH_"ɕύX
//
//  Release 1.0
//      ESiLabsUSB-MSD-RD(Release 1.1)ɁCTimpy Rev5.0pɑSʓIɕύX
//      ESDCCֈڐA
//      Esvȋ@\폜
//
//-----------------------------------------------------------------------------
//
//  Copyright 2006 Silicon Laboratories, Inc.
//  http://www.silabs.com
//
//  Release 1.1
//    -All changes by PKC
//    -09 JUN 2006
//    -No changes; incremented revision number to match project revision
//
//  Release 1.0
//    -Initial Release
//
//-----------------------------------------------------------------------------
//  Header File Preprocessor Directive
//-----------------------------------------------------------------------------

#ifndef _SECT_SERV_H_
#define _SECT_SERV_H_

#include "TimpyH_Common_Defs.h"
#include "TimpyH_MSD_MMC.h"

//-----------------------------------------------------------------------------
//  Structure Prototypes
//-----------------------------------------------------------------------------

// This large bootrecord will be overlayed on the physical block that was read.
typedef struct {
    BYTE  jmp[3];
    char  oem_name[8];
    UINT  bytes_per_sector;
    BYTE  sectors_per_cluster;
    UINT  reserved_sectors;
    BYTE  fat_copies;
    UINT  root_directory_entries;
    UINT  number_of_sectors;
    BYTE  media_descriptor;
    UINT  sectors_per_fat;
    UINT  sectors_per_track;
    UINT  heads;
    ULONG hidden_sectors;
    ULONG total_sectors;
    BYTE  drive_number;
    BYTE  reserved;
    BYTE  extended_signature;   // 0x29
    BYTE  serial_number[4];
    char  volume_label[11];
    char  filesystem[8];        // "FAT16   "
    BYTE  bootstrap[448];
    BYTE  signature[2];         // 0x55 0xAA
} bootrecord_large;

// This small bootrecord will be in memory as long as the program is running
typedef struct {
    BYTE  valid;
    BYTE  fat_copies;
    UINT  root_directory_entries;
    UINT  number_of_sectors;
    UINT  sectors_per_fat;
    ULONG total_sectors;
    UINT  reserved_sectors;
    UINT  hidden_sectors;
    BYTE  sectors_per_cluster;
} bootrecord_small;

// This is a global 512-byte buffer. 
// Sect_Read() puts data in this buffer.
// Sect_Write() gets data from this buffer.
extern BYTE __xdata Scratch[];

// Changed these functions into #define, to safe code memory.
#define Sect_Block_Size()       ((UINT) PHYSICAL_BLOCK_SIZE)
//#define Sect_Fat1()           ((UINT) 1)

//-----------------------------------------------------------------------------
//  Function Prototypes
//-----------------------------------------------------------------------------

void Sect_Init(void);                           // Must be called before calling any other Sect_Function.
BYTE Sect_Formatted(void);                      // Returns TRUE is MMC card appears to be correctly formatted.
ULONG Sect_Sectors(void);                       // Returns number of sectors
ULONG Sect_Size(void);                          // Returns number of bytes available on MMC card.
void Sect_Print(void);                          // Dumps some info (size, bootrecord, filesystem, etc).
UINT Sect_Read(ULONG sector);                   // Reads one sector into Scratch buffer.
void Sect_Write(ULONG sector);                  // Write one sector from Scratch buffer.
UINT Sect_Root_Dir(void);                       // Returns sector number of root directory.
UINT Sect_Root_Dir_Last(void);                  // Last sector number of root directory.
UINT Sect_File_Data(void);                      // First sector of file data.
UINT Sect_Fat1(void);                           // First sector of 1st FAT.
UINT Sect_Fat2(void);                           // First sector of 2nd FAT.
void Sect_Write_Multi_Fat(ULONG sector);        // Automatically handle multiple FAT copies.
void Sect_Validate(void) reentrant;

#endif

/* End of TimpyH_MSD_Sect_Serv.h */
