//-----------------------------------------------------------------------------
// TimpyH_MSD_USB_Descriptor.h
//-----------------------------------------------------------------------------
//
//  Copyright 2006, 2007 Chiaki Nakajima
//  Original copyright 2006 Silicon Laboratories, Inc.
//
//  Release 1.1
//      E\[X̐
//      EgpvZbTF340ɌC"__F340_VER__"`QƂ폜
//      Et@C"F34x_""TimpyH_"ɕύX
//
//  Release 1.0
//      ESiLabsUSB-MSD-RD(Release 1.1)ɁCTimpy Rev5.0pɑSʓIɕύX
//      ESDCCֈڐA
//      Esvȋ@\폜
//
//-----------------------------------------------------------------------------
//
//  Copyright 2006 Silicon Laboratories, Inc.
//  http://www.silabs.com
//
//  Release 1.1
//    -All changes by PKC
//    -09 JUN 2006
//    -No changes; incremented revision number to match project revision
//
//  Release 1.0
//    -Initial Release
//
//-----------------------------------------------------------------------------
//  Header File Preprocessor Directive
//-----------------------------------------------------------------------------

#ifndef _USB_DESC_H_
#define _USB_DESC_H_

#include "TimpyH_Common_Defs.h"

//-------------------------------------------
//  Standard Device Descriptor Type Defintion
//-------------------------------------------
typedef struct {
    BYTE bLength;               // Size of this Descriptor in Bytes
    BYTE bDescriptorType;       // Descriptor Type (=1)
    WORD bcdUSB;                // USB Spec Release Number in BCD
    BYTE bDeviceClass;          // Device Class Code
    BYTE bDeviceSubClass;       // Device Subclass Code	
    BYTE bDeviceProtocol;       // Device Protocol Code
    BYTE bMaxPacketSize0;       // Maximum Packet Size for EP0 
    WORD idVendor;              // Vendor ID 
    WORD idProduct;             // Product ID
    WORD bcdDevice;             // Device Release Number in BCD
    BYTE iManufacturer;         // Index of String Desc for Manufacturer
    BYTE iProduct;              // Index of String Desc for Product
    BYTE iSerialNumber;         // Index of String Desc for SerNo
    BYTE bNumConfigurations;    // Number of possible Configurations
} device_descriptor;            // End of Device Descriptor Type

//---------------------------------------------------
//  Standard Configuration Descriptor Type Definition
//---------------------------------------------------
typedef struct {
    BYTE bLength;               // Size of this Descriptor in Bytes
    BYTE bDescriptorType;       // Descriptor Type (=2)
    WORD wTotalLength;          // Total Length of Data for this Conf
    BYTE bNumInterfaces;        // No of Interfaces supported by this Conf
    BYTE bConfigurationValue;   // Designator Value for *this* Configuration
    BYTE iConfiguration;        // Index of String Desc for this Conf
    BYTE bmAttributes;          // Configuration Characteristics (see below)
    BYTE bMaxPower;             // Max. Power Consumption in this Conf (*2mA)
} configuration_descriptor;     // End of Configuration Descriptor Type

//-----------------------------------------------
//  Standard Interface Descriptor Type Definition
//-----------------------------------------------
typedef struct {
    BYTE bLength;               // Size of this Descriptor in Bytes
    BYTE bDescriptorType;       // Descriptor Type (=4)
    BYTE bInterfaceNumber;      // Number of *this* Interface (0..)
    BYTE bAlternateSetting;     // Alternative for this Interface (if any)
    BYTE bNumEndpoints;         // No of EPs used by this IF (excl. EP0)
    BYTE bInterfaceClass;       // Interface Class Code
    BYTE bInterfaceSubClass;    // Interface Subclass Code
    BYTE bInterfaceProtocol;    // Interface Protocol Code
    BYTE iInterface;            // Index of String Desc for this Interface
} interface_descriptor;         // End of Interface Descriptor Type

//----------------------------------------------
//  Standard Endpoint Descriptor Type Definition
//----------------------------------------------
typedef struct {
    BYTE bLength;               // Size of this Descriptor in Bytes
    BYTE bDescriptorType;       // Descriptor Type (=5)
    BYTE bEndpointAddress;      // Endpoint Address (Number + Direction)
    BYTE bmAttributes;          // Endpoint Attributes (Transfer Type)
    WORD wMaxPacketSize;        // Max. Endpoint Packet Size
    BYTE bInterval;             // Polling Interval (Interrupt) ms
} endpoint_descriptor;          // End of Endpoint Descriptor Type

//------------------------------
//  Setup Packet Type Definition
//------------------------------
typedef struct {
    BYTE bmRequestType;         // Request recipient, type, and direction
    BYTE bRequest;              // Specific standard request number
    WORD wValue;                // varies according to request
    WORD wIndex;                // varies according to request
    WORD wLength;               // Number of bytes to transfer
} setup_buffer;                 // End of Setup Packet Type

#endif  /* _USB_DESC_H_ */

/* End of TimpyH_MSD_USB_Descriptor.h */
