//-----------------------------------------------------------------------------
//  TimpyH_MSD_USB_Main.c
//-----------------------------------------------------------------------------
//
//  Copyright 2006, 2007 Chiaki Nakajima
//  Original copyright 2006 Silicon Laboratories, Inc.
//
//  Release 1.1
//      E\[X̐
//      EgpvZbTF340ɌC"__F340_VER__"`QƂ폜
//      Et@C"F34x_""TimpyH_"ɕύX
//
//  Release 1.0
//      ESiLabsUSB-MSD-RD(Release 1.1)ɁCTimpy Rev5.0pɑSʓIɕύX
//      ESDCCֈڐA
//      Esvȋ@\폜
//
//-----------------------------------------------------------------------------
//
//  Copyright 2006 Silicon Laboratories, Inc.
//  http://www.silabs.com
//
//  REVISIONS:  11/22/02 - DM:  Added support for switches and sample USB
//  interrupt application.
//
//  Release 1.1
//    -All changes by PKC
//    -09 JUN 2006
//    -Replaced SFR definitions file "c8051f320.h" with "c8051f340.h"
//
//  Release 1.0
//    -Initial Release
//
//-----------------------------------------------------------------------------
//  Includes
//-----------------------------------------------------------------------------

#include <c8051f340.h>
#include "TimpyH_Common_Defs.h"
#include "TimpyH_MSD_USB_Register.h"
#include "TimpyH_MSD_USB_Main.h"
#include "TimpyH_MSD_USB_Descriptor.h"
#include "TimpyH_MSD_Sect_Serv.h"
#include "TimpyH_MSD_Msd.h"

//-----------------------------------------------------------------------------
//  Main Routine
//-----------------------------------------------------------------------------

extern void Wait_us_asm(UINT count);    // AZuɂ

volatile ULONG __xdata tickcount = 0;

//----------------------------------------------------------------------------
//  main
//----------------------------------------------------------------------------
//
//  Main loop
//
//  Parameters   :
//  Return Value :
//----------------------------------------------------------------------------

void main(void)
{
//  PCA0MD &= ~0x40;                    // Disable Watchdog timer
    Sys_Clk_Init();                     // Initialize oscillator
    Port_Init();                        // Initialize crossbar and GPIO
    Sect_Init();
    Timer_Init();                       // Initialize timer2
    USB0_Init();                        // Initialize USB0
    USB_Bulk_Init();


    while (1) {
/*
        P3_6 = 0;                       // for measurement
        Wait_us_asm(100);
        P3_6 = 1;                       // for measurement
*/
        Msd_Step();
        if ((REG0CN & 0x40) == 0)       // VBUS = "L"Ȃ
            Reset_MCU();                // \tgEFAZbg
    }
}

//----------------------------------------------------------------------------
//  Sys_Clk_Init
//----------------------------------------------------------------------------
//
//  This routine initilizes the system clock and USB clock
//
//  Parameters   :
//  Return Value :
//----------------------------------------------------------------------------

void Sys_Clk_Init(void)
{
    OSCICN |= 0x03;                     // Configure internal oscillator for
                                        // its maximum frequency and enable
                                        // missing clock detector

    CLKMUL  = 0x00;                     // Select internal oscillator as 
                                        // input to clock multiplier

    CLKMUL |= 0x80;                     // Enable clock multiplier
    Wait_us_asm(5);                     // Delay for clock multiplier to begin
    CLKMUL |= 0xC0;                     // Initialize the clock multiplier
    Wait_us_asm(5);

    while (!(CLKMUL & 0x20)) {          // Wait for multiplier to lock
        /* Do nothing */
    }
    
    CLKSEL = SYS_4X_MUL;
    CLKSEL |= USB_4X_CLOCK;             // Select USB clock
}

//----------------------------------------------------------------------------
//  Port_Init
//----------------------------------------------------------------------------
//
//  Configure the Crossbar and GPIO ports.
//
//  Parameters   :
//  Return Value :
//----------------------------------------------------------------------------

void Port_Init(void)
{
    P0 = 0xdf;
    P0MDIN  = 0x3f;
    P0MDOUT = 0x2d;
    P0SKIP  = 0xf8;

    P1 = 0xff;
    P1MDIN  = 0xff;
    P1MDOUT = 0x60;
    P1SKIP  = 0xff;

    P2 = 0xee;
    P2MDIN  = 0xbf;
    P2MDOUT = 0x1f;
    P2SKIP  = 0xff;

    P3 = 0xff;
    P3MDIN  = 0xff;
    P3MDOUT = 0x76;
    P3SKIP  = 0xff;

    P4 = 0xff;
    P4MDIN  = 0xff;
    P4MDOUT = 0xc0;

    XBR0 = 0x02;
    XBR1 = 0x40;
}

//----------------------------------------------------------------------------
//  USB0_Init
//----------------------------------------------------------------------------
//
//  USB Initialization
//  - Initialize USB0
//  - Enable USB0 interrupts
//  - Enable USB0 transceiver
//  - Enable USB0 with suspend detection
//
//  Parameters   :
//  Return Value :
//----------------------------------------------------------------------------

void USB0_Init(void)
{
    POLL_WRITE_BYTE(POWER,  0x08);      // Force Asynchronous USB Reset
    POLL_WRITE_BYTE(IN1IE,  0x07);      // Enable Endpoint 0-2 in interrupts
    POLL_WRITE_BYTE(OUT1IE, 0x07);      // Enable Endpoint 0-2 out interrupts
    POLL_WRITE_BYTE(CMIE,   0x07);      // Enable Reset, Resume, and Suspend interrupts
    USB0XCN = 0xE0;                     // Enable transceiver; select full speed
    POLL_WRITE_BYTE(CLKREC, 0x80);      // Enable clock recovery, single-step mode

    EIE1 |= 0x02;                       // Enable USB0 Interrupts
    EA = 1;                             // Global Interrupt enable
    POLL_WRITE_BYTE(POWER,  0x01);      // Enable USB0 by clearing the USB Inhibit bit
                                        // and enable suspend detection
}

//----------------------------------------------------------------------------
//  Timer_Init
//----------------------------------------------------------------------------
//
//  Timer initialization
//  - Timer 2 reload, used to check if switch pressed on overflow and
//  used for ADC continuous conversion
//
//  Parameters   :
//  Return Value :
//----------------------------------------------------------------------------

void Timer_Init(void)
{
    TMR2CN  = 0x00;                     // Stop Timer2; Clear TF2;
    CKCON  &= ~0xF0;                    // Timer2 clocked based on T2XCLK;
    TMR2RL  = 0xF000;                   // Initialize reload value
    TMR2    = 0xffff;                   // Set to reload immediately

    ET2     = 1;                        // Enable Timer2 interrupts
    TR2     = 1;                        // Start Timer2
}

//----------------------------------------------------------------------------
//  Timer2_ISR
//----------------------------------------------------------------------------
//
//  Timer 2 interrupt routine
//  Called when timer 2 overflows
//
//  Parameters   :
//  Return Value :
//----------------------------------------------------------------------------

void Timer2_ISR(void) interrupt 5
{
    tickcount++;

    TMR2RL = 0xF05e;
//  TMR2RL = 0xFC16; 
//  TMR2RL = 0xE0B0;                    // Re-initialize reload value (125Hz, 8ms)
    TF2H=0;                             // Clear interrupt
}

//----------------------------------------------------------------------------
//  _sdcc_external_startup
//----------------------------------------------------------------------------

unsigned char _sdcc_external_startup(void)
{
    PCA0MD &= ~0x40;                    // Disable Watchdog timer
    
    return 0;
}

/* End of TimpyH_MSD_USB_Main.c */
